Group {
   children [
      DEF HudGroup Collision {
 	 collide FALSE
	 children [
	    DEF HudProx ProximitySensor {
	       center 0 1.8 30
	       size 200 200 200
	    }
	    DEF HudXform Transform {
	       children [
		  Transform {
		     translation 0 -0.05 -0.15
		     children [
		        Shape {
		           appearance Appearance {
			      material Material {
			         diffuseColor .8 .8 0
			      }
		           }
		           geometry DEF HudText Text { 
			      string "" 
			      fontStyle FontStyle {
                                 size    0.01
                                 justify "MIDDLE"
                              }
  		           }
		        }
		     ]
		  }
	       ]
	    }
	 ]
	 ROUTE HudProx.position_changed TO HudProx.center
	 ROUTE HudProx.orientation_changed  TO HudXform.rotation
	 ROUTE HudProx.position_changed  TO HudXform.translation
      }
   ]
}
PROTO ShowFilename [ 
      field SFString filename ""
      field SFString filesize ""
      eventIn SFBool aBool 
      eventOut MFString string   ]
   { Script {
   field SFString filename IS filename
   field SFString filesize IS filesize 
   eventIn SFBool aBool IS aBool
   eventOut MFString string IS string
   url "vrmlscript:
      function aBool() {
	string[0] = filename;
	string[1] = filesize;
   }"
  }
}