PROTO RotateProto [
        field SFInt32 nrChildren 1
	field SFTime rotateSpeed 1
	eventIn SFBool aBool
        eventOut SFRotation set_rotation
    ]{
     DEF RotTime TimeSensor {
	cycleInterval IS rotateSpeed
	loop FALSE 
	enabled TRUE
	startTime 1 
     }
     DEF Scrpt Script { 
	eventIn SFBool initProces IS aBool
	field SFBool b TRUE
	field SFInt32 child 0 
	field SFFloat stepSize 0
	field SFInt32 nrChildren IS nrChildren
	field SFFloat nulRot 0.0
	eventOut SFTime startTouch
	eventIn SFFloat set_fraction
	eventOut SFRotation set_rotation IS set_rotation
        url "vrmlscript:
	function initProces(f, tm){
	     if (b) {		 
                stepSize = 6.28 / nrChildren;
	        nulRot = child * stepSize;
 	        child = (child + 1)%nrChildren;		
	        startTouch = tm;
	     }
	     b = !b;
        }
	function set_fraction(f, tm){
		set_rotation[0] = 1;
		set_rotation[1] = 0;
		set_rotation[2] = 0;
		set_rotation[3] = nulRot + stepSize * f;
	}"
     }
     ROUTE Scrpt.startTouch TO RotTime.set_startTime
     ROUTE RotTime.fraction_changed TO Scrpt.set_fraction
}